﻿// PlaceMultipagePDF_inFrameWithSelectedSizes.jsx
// InDesign CS3, CS4
//  © Михаил Иванюшин, 2009 г.
//
// Программа позволяет перед импортом PDF-файла задать отступы верхнего левого угла фрейма и его размер.
// Размеры можно вводить только в миллиметрах.
// По умолчанию вводятся нулевые значения отступа и размер фрейма определяется равным размеру страницы.
// Можно выбрать -- помещать картинку в масштабе 100% или, пропорционально увеличив, подогнать её под размер фрейма.
// Если картинка больше фрейма, она будет обязательно уменьшена и подогнана под его размер.
//
// За основу взят скрипт PlaceMultipagePDF.jsx из учебных скриптов.
//
// Возможное развитие скрипта: выбор опций размещения рисунка: Bounding Box, Artwork, Trim.... 
// В этоой программе этот параметр не выбирается, а назначается -- cropMedia.
//

myProgramTitul = "Печать PDF файла с указанием размеров фрейма (07.09.09)";
with (app) { //app
var myDocument = documents.item(0);
if (documents.length < 1) {
		alert("Нет открытых документов.", myProgramTitul);	
		exit();
	}
var mySelection = selection[0];
myOutSize = false; // если надо разрешить запуск скрипта в случае, когда фрейм выходит за пределы страницы, этой переменной надо  присвоить значение true
var myLeftShiftX;
var myLeftShiftY;
var myBoxWidth;
var myBoxHeight;
var myBoxWidthMenu;
var myBoxHeightMenu;
var myScale;
var myFitIn
var myFitInSelect;
var myPageHeight, myPageWidth;
var myPage;
var myFrame;
var myPDF;
var myLeftPicture, myRightPicture;
var myIndx0, myIndx1, myIndx2, myIndx3;
with (myDocument.documentPreferences) { //*//
myPageHeight = pageHeight;
myPageWidth = pageWidth;
} //*//
if (myDocument.pages.length >1) {
		alert("Для решения этой задачи в файле должна быть только одна страница.\nФреймы на страницах рисовать не надо, этот скрипт сам их создаст  \nи разместит в них все страницы выбранного файла.", myProgramTitul);
		exit();
	}
var myPDFFile = File.openDialog(myProgramTitul, 'Файлы PDF: *.pdf');
if (myPDFFile == null) { //~*//
	exit();
	}  //~*//
myDocName = app.documents.item(0).name;
var myDialog = app.dialogs.add({name:"    " + myProgramTitul, canCancel:true});
with (myDialog.dialogColumns.add()) { //FG
with (dialogRows.add().borderPanels.add().dialogColumns.add()) { //HH
with (dialogRows.add()) { //LK
with(dialogColumns.add()) { //UY
	with (dialogColumns.add()) { //BY
		staticTexts.add({staticLabel:"Отступ слева,  мм "});
		staticTexts.add({staticLabel:"Отступ сверху, мм "});
		with (dialogColumns.add()) { //D2
			myLeftShiftX = dialogRows.add().measurementEditboxes.add({editValue:0, editUnits:2053991795}); // 2053991795 -- нумератор, указывающий, что размеры задаются в мм
			myLeftShiftY = dialogRows.add().measurementEditboxes.add({editValue:0, editUnits:2053991795});
			} //D2
		with (dialogColumns.add()) { //D3
			staticTexts.add({staticLabel:"  Ширина, мм "});
			staticTexts.add({staticLabel:"  Высота,  мм "});
			} //D3
		with (dialogColumns.add()) { //D2
			var myFactor = 72 / 25.4;
			var myWidthInMenu = myPageWidth * myFactor;
			var myHeightInMenu = myPageHeight * myFactor;
			// Этот виджет measurementEditboxes наивно думает, что размеры могут быть только в пунктах. 
			// Вот и приходится с помощью коэффициента myFactor пересчитывать размеры.
			myBoxWidthMenu = dialogRows.add().measurementEditboxes.add({editValue:myWidthInMenu, editUnits:2053991795}); // 2053991795 -- нумератор, указывающий, что размеры задаются в мм
			myBoxHeightMenu = dialogRows.add().measurementEditboxes.add({editValue:myHeightInMenu, editUnits:2053991795});
			} //D2
		} //BY
	} //UY
} //LK
with (dialogRows.add().dialogColumns.add()) { // +
	myFitIn = checkboxControls.add({staticLabel:" Подогнать картинку под размер фрейма", checkedState:false})
} // +

} //HH
with (dialogRows.add().dialogColumns.add()) { // +
		staticTexts.add({staticLabel:"       © Михаил Иванюшин, 2009 г."});
} // +
} //FG
if (myDialog.show() == true) { //true
// Хоть пользователь ввёл размеры в мм, программа в том виджете считает, что размеры были введены в пунктах.
// Поэтому выполняется пересчет из пунктов в миллиметры.
var myLeftX = myLeftShiftX.editValue * 25.4 / 72;
var myLeftY = myLeftShiftY.editValue * 25.4 / 72;
var myBoxWidth = myBoxWidthMenu.editValue * 25.4 / 72;
var myBoxHeight = myBoxHeightMenu.editValue * 25.4 / 72;
if (myFitIn.checkedState == true) { myFitInSelect = true; }
else { myFitInSelect = false; }
myDialog.destroy();
} //true
else { //false
myDialog.destroy();
exit();
} //false
if ((myBoxWidth ==0) || (myBoxHeight == 0)) { // box=0	
		alert("Фрейма со стороной 0 мм быть не может.", myProgramTitul);
		exit();
}  // box=0
if (myOutSize == false) { // myOutSize
	if (((myBoxWidth + myLeftX) > myPageWidth) || ((myBoxHeight + myLeftY) > myPageHeight)) { // outsize	
		alert("Фрейм выходит за пределы страницы.", myProgramTitul);
		exit();
	}  // outsize
} //myOutSize
myPlacePDF(myDocument, myDocument.pages.item(0), myPDFFile); // myDocument.pages.item(0) -- ссылка на первую страницу документа
alert("Всё!\nА ручками так быстро заполнить фреймы вряд ли бы удалось. :))", myProgramTitul);
exit();
} //app
////////////////////
function myPlacePDF(myDocument, myPage, myPDFFile) { //function
var myPDFPage;
app.pdfPlacePreferences.pdfCrop = PDFCrop.cropMedia;
var myCounter = 1; // Эта переменная -- указатель текущей страницы, выводимой из PDF файла.
							// Кроме того, когда эта переменная равна 1, программа запоминает номер первой страницы PDF-файла.
							// Когда myCounter больше единицы, в каждом цикле в конец работы добавляется новая страница.
var myBreak = false;
while (myBreak == false) { // == false
	if(myCounter > 1){ //>1
			myPage = myDocument.pages.add(LocationOptions.AT_END, myPage, SelectionOptions.ADD_TO); // во втором и последующих циклах добавляем новую страницу после текущей и теперь она будет иметь имя myPage
			
		} //>1
	
var myDocument = app.activeDocument;
var myPages = myDocument.pages;
//Select last page.
//myDocument.select(myPages.item(-1), SelectionOptions.ADD_TO);
var myPage =  app.activeWindow.activePage;
myDocument.select(myPages.item(-1), SelectionOptions.ADD_TO);

	app.pdfPlacePreferences.pageNumber = myCounter; // ожидаемый номер очередной страницы в PDF файле. 
																		// Если еще не все страницы выведены, содержимое app.pdfPlacePreferences.pageNumber станет равным новому значению переменной myCounter.
																// Если страниц больше нет, то app.pdfPlacePreferences.pageNumber будет постоянно возвращать номер первой страницы PDF файла.
	



	myPDFPage = myPage.place(File(myPDFFile), [0,0])[0];   // в этой строке создается фрейм на текущей странице, и в него помещается очередная страница PDF файла. 
																				// myPDFPage -- ссылка на рисунок в фрейме (будто его выбрали Белой стрелкой). 
																				// Что это именно так, можно убедиться, выполнив в режиме отладки команду app.select (myPDFPage);
																				// [0.0] -- координаты левого верхнего угла фрейма, при нулевых значениях этот массив можно и не указывать.
	



	var myBoxForPDF = myPDFPage.parent; // указатель на фрейм, в который только что поместили картинку
	myBoxForPDF.geometricBounds = [myLeftY,myLeftX,myLeftY + myBoxHeight, myLeftX + myBoxWidth]; // изменяем его размеры
	with (myPDFPage) { //with
		// информация о размерах картинки
		myIndx0 = geometricBounds[0]; // Y1
		myIndx1 = geometricBounds[1]; //X1
		myIndx2 = geometricBounds[2]; //Y2
		myIndx3 = geometricBounds[3]; // X2
		}  //with
	if (((myIndx3 - myIndx1) > myBoxWidth) || ((myIndx2 - myIndx0) > myBoxHeight)) { myFitInSelect = true; } // если картинка больше фрейма, она будет обязательно пропорционально подогнана под его размер
	with (myBoxForPDF) { //KJ
		strokeWeight = 0;
// подгоняем картинку под прямоугольник с сохранением пропорций
	//	fit (FitOptions.CONTENT_TO_FRAME);
		if (myFitInSelect == true) 	{ fit (FitOptions.PROPORTIONALLY); }
	//////	fit (FitOptions.CENTER_CONTENT); 	
		} //KJ
	if(myCounter == 1){ //==1
			var myFirstPage = myPDFPage.pdfAttributes.pageNumber; // в первом цикле запоминаем номер первой страницы PDF файла.
		} //==1
	else{ //else
		// после того, как все страницы файла будут размещены, 
		//содержимое app.pdfPlacePreferences.pageNumber будет постоянно указывать на первую страницу файла
			if(myPDFPage.pdfAttributes.pageNumber == myFirstPage){ //remove
				myPage.remove(); // Ранее страницу добавили и поместили на неё очередную страницу из обрабатывемого файла.
										 //Но поскольку оказалось, что тут повторно размещена первая страница файла, эту страницу документа перед завершением работы надо удалить. 
				myBreak = true;
			} //remove
		} //else
		myCounter = myCounter + 1;
	} // == false
} //function


